function [Krd,Kd,Ld,Ad,Bd,Cd] = dt2obs(Ad,Bd,Cd,useAnalytic,deltaT)
% ===================================================================
% Determine the feedback controller (Krd, Kd) and estimator gains (Ld)
% for an DT Ad, Bd, Cd system:
% x[n+1] = Ad*x[n] + Bd*u[n], 
% u[n] = Krd*y_d[n] - K*x[n].
% y[n] = Cd*x[n].
% Include deltaT if adding an integral term.
% ====================================================================

assert(size(Ad,1) == 3); % Change if not a 3-state system.

% 3x3 Q matrix Q(i,i) = 1, 1x1 R matrix, R(i,i) = 1, (identity matrices)
%************************ FIX THIS! Pick good LQR weights.
if useAnalytic
    Q = diag([1.0,1.0,1.0]); %FIX THIS 
    R = 1.0;
    Kd = dlqr(Ad,Bd,Q,R);  
else
    Q = diag([1.0,1.0,1.0]);  % FIX THIS Don't know states in fit model.
    R = 1.0;
    Kd = dlqr(Ad,Bd,Q,R);  %FIX THIS (Uncomment when using LQR
end
% FIX THIS!!! Comment out this line when using LQR
Kd = [1.0,0.075,0];

% Compute closed-loop matrix to compute Kr and measured-state fdbk poles
Adcl = Ad; % FIX THIS!!!

Krd = 1.0; % ***********FIX THIS!!!!!!! NOT SAME FORMULA AS CT CASE!!!

% =========
% Compute the gains for the observer system
% xEst[n+1] = Ad*xEst[n] + Bd*u[n] + Ld*[y[n]-yEst[n])
% =========

% Observer starts HERE!!!
%***************FIX THESE!!!! How do you use Ad and Cd?
%Ld = place(Ad, Bd,1.0*[0.3,0.1,0.2])';  % FIX THIS!!!
Ld = [1.0,1.0,1.0]';  % FIX THIS Comment out when Ld is computed.
Adlc = Ad;  % Estimation System: FIX THIS!!!

disp('*****Gains*****');
disp(['Krd:',num2str(Krd)]);
disp(['Kd Gains:    ',num2str(Kd)]);
disp(['Ld gains:   ',num2str(Ld')]);

disp('*****Poles*****');
disp(['poles DT meas-state-feedback (r->y):  ', num2str(eig(Adcl).')]);
disp(['poles DT estimation-error (r->(y-yEst))  ', num2str(eig(Adlc).')]);
disp(['|poles| DT meas-state-feedback (r->y):  ', num2str(sort(abs(eig(Adcl)).'))]);
disp(['|poles| DT estimation-error (r->(y-yEst))  ', num2str(sort(abs(eig(Adlc)).'))]);
